using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WinFontGenerator
{
    public partial class Form1 : Form
    {
        Bitmap bmpTexture;
        Font fonttosend;
        public Form1()
        {
            InitializeComponent();
            PAtype.Items.Add("Normal");
            PAtype.Items.Add("8 bit");
            PAtype.Items.Add("16 colors");
            PAtype.SelectedIndex = 0;
            fonttosend = textBox1.Font;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.ForeColor = colorDialog1.Color;
            }
        }
         
        private void button2_Click(object sender, EventArgs e)
        {
            if (PAtype.SelectedIndex == 0) {fontDialog1.MinSize = 8; fontDialog1.MaxSize = 8;}
            else {fontDialog1.MinSize=(int) FontSize.Value; fontDialog1.MaxSize=(int) FontSize.Value;}

            if (fixedpitch.Checked) fontDialog1.FixedPitchOnly = true;
            else fontDialog1.FixedPitchOnly = false;
  
            if (fontDialog1.ShowDialog() == DialogResult.OK)
            {
                if (PAtype.SelectedIndex == 0) fonttosend = new Font(fontDialog1.Font.FontFamily, (float) 8, fontDialog1.Font.Style, System.Drawing.GraphicsUnit.Pixel);
                else                           fonttosend = new Font(fontDialog1.Font.FontFamily, (float) FontSize.Value, fontDialog1.Font.Style, System.Drawing.GraphicsUnit.Pixel);
                textBox1.Font = fonttosend;
                button4.Enabled = true;
            }
        }
        private void button3_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.BackColor = colorDialog1.Color;
            }
        }

        private void bTexture_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                bmpTexture = new Bitmap(openFileDialog1.FileName);
                pictureBox1.Image = bmpTexture;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Resultat frmResultat;
            if (textured.Checked)
                frmResultat = new Resultat(textBox1.BackColor, textBox1.ForeColor, fonttosend, FontSize.Value, full.Checked, bmpTexture);
            else
                frmResultat = new Resultat(textBox1.BackColor, textBox1.ForeColor, fonttosend, FontSize.Value, full.Checked);
            frmResultat.Show();
        }

        private void textured_CheckedChanged(object sender, EventArgs e)
        {
            if (textured.Checked)
            {
                bTexture.Enabled = true;
            }
            else
            {
                bTexture.Enabled = false;
            }
        }

        private void PAtype_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (PAtype.SelectedIndex == 0) FontSize.Enabled = false;
            else                           FontSize.Enabled = true;
        }

        private void fixedpitch_CheckedChanged(object sender, EventArgs e)
        {
            button4.Enabled = false;
        }

        private void perfectsize_CheckedChanged(object sender, EventArgs e)
        {
            button4.Enabled = false;
        }

        private void pixel_CheckedChanged(object sender, EventArgs e)
        {
            button4.Enabled = false;
        }
    }
}