using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace WinFontGenerator
{
    public partial class Resultat : Form
    {
        Bitmap bmpFont;
        Bitmap bmpTexture;
        Graphics grFont;
        int  fontsize;
        bool textured;
        bool full;
        int modifier;

        public Resultat(Color colorFond, Color colorFont, Font fontEcriture, decimal size, bool fu)
        {
            InitializeComponent();
            fontsize = (int) size;
            full = fu;
            textured = false;
            //on va crer l'image
            NouvelleImage();
            grFont = Graphics.FromImage(bmpFont);
            picDessin.Image = bmpFont;
            BackgroundBmp(colorFond);
            CreerPolice(fontEcriture,colorFont);
            //on fait la fenetre de la bonne taille
            Redimentionne_fenetre();
        }

        public Resultat(Color colorFond, Color colorFont, Font fontEcriture, decimal size, bool fu, Bitmap bmp)
        {
            InitializeComponent();
            fontsize = (int) size;
            full = fu;
            bmpTexture = bmp;
            textured = true;
            //on va crer l'image
            NouvelleImage();
            grFont = Graphics.FromImage(bmpFont);
            picDessin.Image = bmpFont;
            BackgroundBmp(colorFond);
            CreerPolice(fontEcriture, colorFont);
            //on fait la fenetre de la bonne taille
            Redimentionne_fenetre();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            saveFileDialog1.Filter = "Image Png|*.png|Image Jpeg|*.jpg|Image Bitmap|*.bmp|Image Gif|*.gif";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string strExtension = Path.GetExtension(saveFileDialog1.FileName);
                strExtension = strExtension.ToLower();
                switch (strExtension)
                {
                    case ".png":                        
                        bmpFont.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Png);
                        break;
                    case ".jpg":
                        bmpFont.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Jpeg);
                        break;
                    case ".bmp":
                        bmpFont.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Bmp);
                        break;
                    case ".gif":
                        bmpFont.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Gif);
                        break;
                }
                
            }
        }
     
        private void BackgroundBmp(Color couleurFond)
        {
            SolidBrush sb = new SolidBrush(couleurFond); //on va colorier le fond de la bonne couleur
            //on fait un rectange de la couleur choisi
            grFont.FillRectangle(sb, 0, 0, bmpFont.Width, bmpFont.Height);
        }

        private void NouvelleImage()
        {
            int width=0;
            int height=0;
            int rows=9;
            int cols=32;

            switch (fontsize)
            {
                case 4: 
                case 5:
                case 6:
                case 7:
                case 8:
                            modifier = 1;
                break;

                case 9:
                case 10:
                case 11:
                case 12:
                case 13:
                case 14:
                case 15:
                case 16:
                            modifier = 2;
                break;
            }

            width = 8 *modifier* cols;
            height = 8 *modifier* rows;     
            bmpFont = new Bitmap(width, height);
            grFont = Graphics.FromImage(bmpFont);
            picDessin.Image = bmpFont;
            picDessin.Width = width;
            picDessin.Height = height;
        }

        private void CreerPolice(Font fontEcriture, Color colorFont )
        {

            fontEcriture = new Font(fontEcriture.FontFamily, fontEcriture.Size, fontEcriture.Style, System.Drawing.GraphicsUnit.Pixel);

            Brush brpen;

            if (textured)
                brpen = new TextureBrush(bmpTexture);
            else
                brpen = new SolidBrush(colorFont);

            if (full)
            {
                for(int i=2, k=32; i<16; i++)
                    for (int y = 0; y < 32; y++, k++)
                    { 
                      string charactere = Char.ToString((char)k);
                      if (k<127 || k>159) 
                      grFont.DrawString(charactere, fontEcriture, brpen, 8 * modifier * y, 8 * modifier * i);
                    }
            }
            else
            {
               for (int i = 2, k = 32; i < 5; i++)
                   for (int y = 0; y < 32; y++, k++)
                   {
                     string charactere = Char.ToString((char)k);
                     grFont.DrawString(charactere, fontEcriture, brpen, 8 * modifier * y, 8 * modifier * i);
                   }
            }
            picDessin.Refresh();
        }

        public void Redimentionne_fenetre()
        {
            this.Width = picDessin.Width + 28;
            this.Height = picDessin.Height + 75;
            this.button1.Location = new System.Drawing.Point(this.button1.Location.X, picDessin.Height + 8);
            btQuitter.Location = new System.Drawing.Point(picDessin.Width - 132, picDessin.Height + 8); 
        }

        private void btQuitter_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Resultat_FormClosing(object sender, FormClosingEventArgs e)
        {
            //ici on va liberer les ressources car le gdi+ n'est pas manag
            bmpFont.Dispose();
            grFont.Dispose();
        }
    }
}